local VEHICLE_MAX_OVERLAY = 4;
local VEHICLE_MAX_ARTWORK = 10;
local VEHICLE_MAX_BORDER = 7;
local VEHICLE_MAX_BACKGROUND = 3;
local vehiclescale = 0.80;
local Semiclass = UnitClass("player");
local Semilevel = UnitLevel("player");
local SemiMaxLevel = MAX_PLAYER_LEVEL;
local Semicombat;
Semiscale = 1;
Semitotemscale = .8;

local TotemButtons = {
    MultiCastSummonSpellButton,
	MultiCastActionPage1,
	MultiCastActionPage2,
	MultiCastActionPage3,
	MultiCastSlotButton1,
	MultiCastSlotButton2,
	MultiCastSlotButton3,
	MultiCastSlotButton4,
	MultiCastFlyoutFrame,
	MultiCastFlyoutButton,
    MultiCastRecallSpellButton,
};

function Semi_LinkMainMenuBarToDragButton()
	UIPARENT_MANAGED_FRAME_POSITIONS["MainMenuBar"] = nil;
	MainMenuBar:ClearAllPoints();
	MainMenuBar:SetPoint("BOTTOM", SemiMainMenuBarDragButton, "BOTTOM");

-- Hiding various textures

MainMenuBarTexture2:Hide();
MainMenuBarTexture3:Hide();
MainMenuMaxLevelBar2:Hide();
MainMenuMaxLevelBar3:Hide();
ReputationWatchBarTexture2:SetTexture("");
ReputationWatchBarTexture3:SetTexture("");
ReputationXPBarTexture2:SetTexture("");
ReputationXPBarTexture3:SetTexture("");
SlidingActionBarTexture0:Hide();
SlidingActionBarTexture1:Hide();
ShapeshiftBarLeft:SetAlpha(0);
ShapeshiftBarMiddle:SetAlpha(0);
ShapeshiftBarRight:SetAlpha(0);


--Moving the visible textures of the MainMenuBar to their right location
	
	MainMenuBar:SetWidth(512);
	MainMenuExpBar:SetWidth(512);
	ReputationWatchBar:SetWidth(512);
	MainMenuBarMaxLevelBar:SetWidth(512);
	ReputationWatchStatusBar:SetWidth(512);
	MainMenuMaxLevelBar0:SetPoint("BOTTOM", "MainMenuBarMaxLevelBar", "TOP", -128, 0);
	MainMenuMaxLevelBar1:SetPoint("BOTTOM", "MainMenuBarMaxLevelBar", "TOP", 128, 0);
	MainMenuBarTexture0:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", -128, 0);
	MainMenuBarTexture1:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", 128, 0);
	MainMenuBarLeftEndCap:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", -290, 0);
	MainMenuBarRightEndCap:SetPoint("BOTTOM", "MainMenuBarArtFrame", "BOTTOM", 290, 0);
	VehicleMenuBar:ClearAllPoints();
	VehicleMenuBar:SetPoint("BOTTOM", SemiMainMenuBarDragButton, "BOTTOM");

	
	if (Semilevel < SemiMaxLevel) then
		for i=10,19 do
			local semitexturehide = _G["MainMenuXPBarDiv"..i];
			if semitexturehide then
				semitexturehide:Hide();
			end
		end

	end
end

function ShowSemiBags()
	MainMenuBarBackpackButton:Show();
	CharacterBag0Slot:Show();
	CharacterBag1Slot:Show();
	CharacterBag2Slot:Show();
	CharacterBag3Slot:Show();
	Semi_LinkInventoryBagsToDragButton();
end

function HideSemiBags()
	MainMenuBarBackpackButton:Hide();
	CharacterBag0Slot:Hide();
	CharacterBag1Slot:Hide();
	CharacterBag2Slot:Hide();
	CharacterBag3Slot:Hide();
end

function ShowSemiMenu()
	CharacterMicroButton:SetAlpha(1);
	SpellbookMicroButton:SetAlpha(1);
	TalentMicroButton:SetAlpha(1);
	AchievementMicroButton:SetAlpha(1);
	QuestLogMicroButton:SetAlpha(1);
	GuildMicroButton:SetAlpha(1);
	PVPMicroButton:SetAlpha(1);
	LFDMicroButton:SetAlpha(1);
	MainMenuMicroButton:SetAlpha(1);
	HelpMicroButton:SetAlpha(1);
	CharacterMicroButton:EnableMouse("true");
	SpellbookMicroButton:EnableMouse("true");
	TalentMicroButton:EnableMouse("true");
	AchievementMicroButton:EnableMouse("true");
	QuestLogMicroButton:EnableMouse("true");
	GuildMicroButton:EnableMouse("true");
	PVPMicroButton:EnableMouse("true");
	LFDMicroButton:EnableMouse("true");
	MainMenuMicroButton:EnableMouse("true");
	HelpMicroButton:EnableMouse("true");
	Semi_LinkMicroMenuToDragButton();
end

function HideSemiMenu()
	CharacterMicroButton:SetAlpha(0);
	SpellbookMicroButton:SetAlpha(0);
	TalentMicroButton:SetAlpha(0);
	AchievementMicroButton:SetAlpha(0);
	QuestLogMicroButton:SetAlpha(0);
	GuildMicroButton:SetAlpha(0);
	PVPMicroButton:SetAlpha(0);
	LFDMicroButton:SetAlpha(0);
	MainMenuMicroButton:SetAlpha(0);
	HelpMicroButton:SetAlpha(0);
	CharacterMicroButton:EnableMouse("false");
	SpellbookMicroButton:EnableMouse("false");
	TalentMicroButton:EnableMouse("false");
	AchievementMicroButton:EnableMouse("false");
	QuestLogMicroButton:EnableMouse("false");
	GuildMicroButton:EnableMouse("false");
	PVPMicroButton:EnableMouse("false");
	LFDMicroButton:EnableMouse("false");
	MainMenuMicroButton:EnableMouse("false");
	HelpMicroButton:EnableMouse("false");
	
end


function SemiActionBars_OnEvent(self, event, ...)
   	if (event=="ADDON_LOADED" or event=="PLAYER_ENTERING_WORLD" or event=="PLAYER_LOGIN") then
		SemiMainMenuBarDragButton:Hide();
		SemiBottomLeftBarDragButton:Hide();
		SemiBottomRightBarDragButton:Hide();
		SemiTotemBarDragButton:Hide();
		SemiMicroMenuDragButton:Hide();
		SemiInventoryBagsDragButton:Hide();
		
		if (Semipartyframes == "hide") then
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();

			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();

			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();

			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();

		else
			Semipartyframes = "show";

			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();
		end
		
		if (SF_MicroMenu_State) then
			ShowSemiMenu();
		elseif (not SF_MicroMenu_State) then
				HideSemiMenu();
		end
		if (SF_Bags_State) then
			ShowSemiBags();
		elseif (not SF_Bags_State) then
			HideSemiBags();
		end
		if (SF_Keyring_State) then
			KeyRingButton:Show();
		elseif (not SF_Keyring_State) then
			KeyRingButton:Hide();
		end
		
		if (Semiclass == "Shaman") and HasMultiCastActionBar then
			SemiTotemBar = CreateFrame("Frame","SemiTotemBar", UIPARENT)
  			SemiTotemBar:SetWidth(220)	--original 220
  			SemiTotemBar:SetHeight(50)	--original 30
			SemiTotemBar:Show()
			for _, f in pairs(TotemButtons) do
				f:SetParent(SemiTotemBar);
			end
			MultiCastSummonSpellButton:ClearAllPoints();
			MultiCastSummonSpellButton:SetPoint("BOTTOMLEFT", 0, 3);
			local semitotempage;
			local semitotembutton;
			for i = 1, NUM_MULTI_CAST_PAGES do
				semitotempage = _G["MultiCastActionPage"..i];
				semitotempage:SetPoint("BOTTOMLEFT", 40, 3);
			end
			for j = 1, NUM_MULTI_CAST_BUTTONS_PER_PAGE do
				semitotembutton = _G["MultiCastSlotButton"..j];
				semitotembutton:SetPoint("BOTTOMLEFT", 40, 3);
    		end

 			MultiCastRecallSpellButton:SetPoint("BOTTOMLEFT", 50, 3);
			
			SemiTotemBar:SetScale(Semiscale*Semitotemscale);
			Semi_LinkTotemBarToDragButton();
		end
		SetMenuBarScale(Semiscale);
		Semi_LinkMicroMenuToDragButton();
		Semi_LinkInventoryBagsToDragButton();
		if (Semiclass ~= "Shaman") then
			SemiTotemBarDragButton:Hide();
		end
		UpdateBarPositions();
	end
   	if (event=="PLAYER_REGEN_ENABLED") and (event=="UPDATE_BONUS_ACTIONBAR" or event=="ACTIONBAR_PAGE_CHANGED") then
		UpdateBarPositions();
	end
	
	if (event=="UNIT_ENTERED_VEHICLE") then
		UpdateVehicleBarPositions();		
	end
	
	if (event=="UNIT_EXITING_VEHICLE") then
		UpdateBarPositions();
	end
	if (event=="PLAYER_TALENT_UPDATE") then
		UpdateBarPositions();
	end
	if (event=="PLAYER_REGEN_ENABLED") then
		Semicombat = "false";
	end
	if (event=="PLAYER_REGEN_DISABLED") then
		Semicombat = "true";
	end


end


function SetMenuBarScale(scale)
	MainMenuBar:SetScale(scale);
	MultiBarRight:SetScale(scale);
	MultiBarLeft:SetScale(scale);
	VehicleMenuBar:SetScale(scale*vehiclescale);
	if SemiTotemBar then
		SemiTotemBar:SetScale(scale*Semitotemscale);
	end
end

local frame = CreateFrame("Frame", "Semi_MyAddOnFrame");
frame:SetScript("OnEvent", SemiActionBars_OnEvent);
frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("PLAYER_LOGIN");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
frame:RegisterEvent("UNIT_ENTERED_VEHICLE");
frame:RegisterEvent("UNIT_EXITING_VEHICLE");
frame:RegisterEvent("PLAYER_REGEN_ENABLED");
frame:RegisterEvent("PLAYER_REGEN_DISABLED");
frame:RegisterEvent("UNIT_PET");
frame:RegisterEvent("UPDATE_MULTI_CAST_ACTIONBAR");
frame:RegisterEvent("PLAYER_TALENT_UPDATE");




local function slashCMD(msg)
	local _, _, command, args, _ = string.find(msg, "^(%w+)%s*(.*)$");
	if ( command == "scale" and args ) then
		Semiscale = args;
		DEFAULT_CHAT_FRAME:AddMessage("The Scale for Semi Action Bars is now "..Semiscale);
		SetMenuBarScale(Semiscale);
	elseif ( command == "totemscale" and args ) then
		Semitotemscale = args;
		DEFAULT_CHAT_FRAME:AddMessage("The Totem Bars scale is now "..Semitotemscale);
		SetMenuBarScale(Semiscale);
	elseif string.lower(msg) == "partyhide" then
		if Semicombat == "true" then
			DEFAULT_CHAT_FRAME:AddMessage("This can only be done out of combat.");
		else
			PartyMemberFrame1:Hide();
			PartyMemberFrame1:UnregisterAllEvents();

			PartyMemberFrame2:Hide();
			PartyMemberFrame2:UnregisterAllEvents();

			PartyMemberFrame3:Hide();
			PartyMemberFrame3:UnregisterAllEvents();

			PartyMemberFrame4:Hide();
			PartyMemberFrame4:UnregisterAllEvents();
			Semipartyframes = "hide";
			DEFAULT_CHAT_FRAME:AddMessage("Party Frames are now HIDDEN!");
		end
	elseif string.lower(msg) == "partyshow" then
		if Semicombat == "true" then
			DEFAULT_CHAT_FRAME:AddMessage("This can only be done out of combat.");
		else
			PartyMemberFrame1:RegisterAllEvents();
			PartyMemberFrame2:RegisterAllEvents();
			PartyMemberFrame3:RegisterAllEvents();
			PartyMemberFrame4:RegisterAllEvents();
			Semipartyframes = "show";

			for p=1, MAX_PARTY_MEMBERS, 1 do
			  if ( GetPartyMember(p) ) then
			     _G["PartyMemberFrame"..p]:Show();
			  end
			end
			DEFAULT_CHAT_FRAME:AddMessage("Party Frames are now SHOWN!");
		end
	elseif string.lower(msg) == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("Semi Action Bars UI Commands:", 1, 1, 1, 53, 15);
		DEFAULT_CHAT_FRAME:AddMessage("Semi Action Bars for 4.0.1");
		DEFAULT_CHAT_FRAME:AddMessage("/semi scale #    - |cffF58CBASets the scale of your action bars ex. /semi scale 0.8", 1, 1, 1, 53, 15);
		DEFAULT_CHAT_FRAME:AddMessage("/semi totemscale # - |cffF58CBASets an additonal scale for your totembar ex. /semi totemscale 0.8", 1, 1, 1, 53, 15);
		DEFAULT_CHAT_FRAME:AddMessage("/semi partyhide - |cffF58CBAHide the party frames", 1, 1, 1, 53, 15);
		DEFAULT_CHAT_FRAME:AddMessage("/semi partyshow - |cffF58CBAShow the party frames", 1, 1, 1, 53, 15);
	else 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00bfffSemi Action Bars v2.1|r '|cff00bfffType|r '|cffffd700/semi help|r' |cff00bffffor Command List.|r", 1, 1, 1, 53, 15);	

	end
end

_G["SlashCmdList"]["Semi_Action_Bars"] = slashCMD
_G["SLASH_SEMI1"] = "/semi"



function UpdateBarPositions()
	if not UnitInVehicle("player") then
		VehicleMenuBar:Hide();
		MainMenuBar:Show();
	end
	if (Semiclass == "Shaman" and HasMultiCastActionBar) then
		Semi_LinkTotemBarToDragButton();
	end
	if (SF_MicroMenu_State) and not UnitInVehicle("player") then
		ShowSemiMenu();
	elseif (not SF_MicroMenu_State) then
			HideSemiMenu();
	end
	if (SF_Bags_State) and not UnitInVehicle("player") then
		ShowSemiBags();
	elseif (not SF_Bags_State) then
		HideSemiBags();
	end
	if (SF_Keyring_State) then
		KeyRingButton:Show();
	elseif (not SF_Keyring_State) then
		KeyRingButton:Hide();
	end

	Semi_LinkMainMenuBarToDragButton();
	Semi_LinkBottomLeftBarToDragButton();
	Semi_LinkBottomRightBarToDragButton();
	Semi_LinkMicroMenuToDragButton();
	Semi_LinkInventoryBagsToDragButton();

end

hooksecurefunc("UIParent_ManageFramePositions", UpdateBarPositions);
hooksecurefunc("SetUpAnimation", UpdateBarPositions);



-------------------------------------
-- FUNCTIONS ------------------------
-------------------------------------


function Semi_LinkTotemBarToDragButton()
		SemiTotemBar:ClearAllPoints();
		SemiTotemBar:SetPoint("BOTTOMLEFT", SemiTotemBarDragButton, "TOPRIGHT");
		
end

-- Function to hide the ShapeshiftBar and PetActionBar textures
function HideJunk()
	SlidingActionBarTexture0:Hide();
	SlidingActionBarTexture1:Hide();
	ShapeshiftBarLeft:SetAlpha(0);
	ShapeshiftBarMiddle:SetAlpha(0);
	ShapeshiftBarRight:SetAlpha(0);
	PetActionBarFrame:EnableMouse("false");
end



-- Bottom left actionbar
function Semi_LinkBottomLeftBarToDragButton()
	UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomLeft"] = nil;
	MultiBarBottomLeft:ClearAllPoints();
	MultiBarBottomLeft:SetPoint("BOTTOM", SemiBottomLeftBarDragButton, "BOTTOM");
end

-- Bottom right actionbar
function Semi_LinkBottomRightBarToDragButton()
	UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomRight"] = nil;
	MultiBarBottomRight:ClearAllPoints();
	MultiBarBottomRight:SetPoint("BOTTOM", SemiBottomRightBarDragButton, "BOTTOM");
end



-- Move the micro menu buttons
function Semi_LinkMicroMenuToDragButton()
	if (not UnitInVehicle("player")) then
		CharacterMicroButton:ClearAllPoints();
		CharacterMicroButton:SetPoint("BOTTOMLEFT", SemiMicroMenuDragButton, "BOTTOMLEFT");
	end
end

-- Move the bags
function Semi_LinkInventoryBagsToDragButton()
	MainMenuBarBackpackButton:ClearAllPoints();
	MainMenuBarBackpackButton:SetPoint("TOPRIGHT", SemiInventoryBagsDragButton, "TOPRIGHT");
end

function UpdateVehicleBarPositions()
	VehicleMenuBarArtFrame:Show();
	VehicleMenuBar:ClearAllPoints();
	VehicleMenuBar:SetPoint("BOTTOM", SemiMainMenuBarDragButton, "BOTTOM");	
	VehicleMenuBar.currSkin = nil;
	for i=1, VEHICLE_MAX_BACKGROUND do
		_G["VehicleMenuBarArtFrameBACKGROUND"..i]:Hide();
	end
	for i=1, VEHICLE_MAX_BORDER do
		_G["VehicleMenuBarArtFrameBORDER"..i]:Hide();
	end
	for i=1, VEHICLE_MAX_ARTWORK do
		_G["VehicleMenuBarArtFrameARTWORK"..i]:Hide();
	end
	if SemiGryphonState == "hide" then
		for i=1, VEHICLE_MAX_OVERLAY do
			_G["VehicleMenuBarArtFrameOVERLAY"..i]:Hide();
		end
	end
end

-- Hiding the actionbar paging buttons/number
MainMenuBarPageNumber:Hide();
ActionBarUpButton:Hide();
ActionBarDownButton:Hide();

-- Hiding various textures
MainMenuBarTexture2:Hide();
MainMenuBarTexture3:Hide();
MainMenuMaxLevelBar2:Hide();
MainMenuMaxLevelBar3:Hide();
ReputationWatchBarTexture2:SetTexture("");
ReputationWatchBarTexture3:SetTexture("");
ReputationXPBarTexture2:SetTexture("");
ReputationXPBarTexture3:SetTexture("");
SlidingActionBarTexture0:Hide();
SlidingActionBarTexture1:Hide();
ShapeshiftBarLeft:Hide();
ShapeshiftBarMiddle:Hide();
ShapeshiftBarRight:Hide();



